using System;
class HelloWorld 
{
    static void citaj(int n, int m, int[,]x)
    {
        for(int i = 0; i < n; i++)
        {
            string[] s = Console.ReadLine().Split(' ');
            for(int j = 0; j < m; j++)
            {
                x[i,j] = int.Parse(s[j]);
            }
        }
    }
    
    static void Main() 
    {
        string[] s1 = Console.ReadLine().Split(' ');
        int n = int.Parse(s1[0]);
        int m = int.Parse(s1[1]);
        int[,] x = new int[n,m];
        citaj(n,m,x);
        int q = int.Parse(Console.ReadLine());
        
        for(int z = 0; z < q; z++)
        {
            s1 = Console.ReadLine().Split(' ');
            int a = int.Parse(s1[0]); a--;
            int b = int.Parse(s1[1]); b--;
        
            int i = 0, j = 0, d = m, min = int.MaxValue;
            if(n == 2)
            {
                for(int k = 0; k < m; k++)
                {
                    int s = 0;

                        bool ispravan = true;
                        for(i = 0; i < d; i++)
                        {
                            s+=x[0,i];
                            if(0 == a && i == b)
                            {
                                ispravan = false;
                                s = int.MaxValue;
                                break;
                            }
                        }
                        if(ispravan)
                        {
                            for(j = i-1; j < m; j++)
                            {
                                s+=x[1,j];
                                if(1 == a && j == b)
                                {
                                    s = int.MaxValue;
                                    break;
                                }
                            }
                        }
                        d--;
                        if(s < min)
                            min = s;
                }
            }
            else
            {
                int s = 0;
                bool ispravan = true;
                for(i = 0; i < m; i++)
                {
                    s+=x[0,i];
                    if(a == 0 && b == i)
                    {
                        ispravan = false;
                        s = 0;
                        break;
                    }
                }
                if(ispravan)
                {
                    for(j = 1; j < n; j++)
                    {
                        s+=x[j,m-1];
                        if(a == j && b == m-1)
                        {
                            ispravan = false;
                            s = 0;
                            break;
                        }
                    }
                }
                if(!ispravan)
                {
                    s = 0;
                    for(i = 0; i < n; i++)
                    {
                        s+=x[i,0];
                    }
                    for(j = 1; j < m; j++)
                    {
                        s+=x[n-1,j];
                    }
                }
                min = s;
            }
            Console.WriteLine(min);
        }
    }
}